.PHONY : clean

CFLAGS= -Werror -Wall
CFLAGS += -fPIC -DNDEBUG
LDFLAGS= -shared
INC= -I./inc -I./inc/memory -I./inc/zcl -I./inc/zcl/misc
INC+= 
PACKAGE_NAME=libzigbee
DEPENDS:=+verik-utils
VER=0
REL=1
LN_S=ln

LKFLAGS= -sf
LDFLAGS+= -pthread -lverik-utils
LDFLAGS+= -Wl,-soname,$(PACKAGE_NAME).so.1

SOURCES = $(shell echo src/*.c)
SOURCES += $(shell echo src/memory/*.c)
SOURCES += $(shell echo src/zcl/*.c)
SOURCES += $(shell echo src/zcl/misc/*.c)

OBJECTS=$(patsubst %.c,%.o,$(notdir $(wildcard src/*.cpp) $(wildcard src/*.c) $(wildcard src/memory/*.c) $(wildcard src/zcl/*.c) $(wildcard src/zcl/misc/*.c)))

TARGET=$(PACKAGE_NAME).so.1.0

all: $(TARGET)

clean:
	@rm -f $(OBJECTS) $(TARGET) $(PACKAGE_NAME).so*
	@rm -fr ./$(PACKAGE_NAME)-$(VER)
	@rm -f *.tar.gz
	@find . -type f -name ".*" -delete
	@rm -fr ipkg-omap

$(OBJECTS): $(SOURCES)
	$(CC) $(INC) $(CFLAGS) -c $(SOURCES)

$(TARGET) : $(OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $^
	$(LN_S) $(LKFLAGS) $(TARGET) $(PACKAGE_NAME).so.1
	$(LN_S) $(LKFLAGS) $(TARGET) $(PACKAGE_NAME).so

package:
	@mkdir -p ./${PACKAGE_NAME}-${VER}
	@cp -fr ./inc ./src  Makefile ./$(PACKAGE_NAME)-${VER}
	tar -cz -f ${PACKAGE_NAME}-${VER}.${REL}.tar.gz ./$(PACKAGE_NAME)-${VER}

install:
	@cp -rf $(PACKAGE_NAME)* ${PREFIX}/usr/lib

release: package
	@echo "Copy Package zigbee Files to Release Folder"
	@if [ ! -d ../../release ]; then mkdir -p ../../release; fi
	@cp $(PACKAGE_NAME)-$(VER).$(REL).tar.gz ../../release
